Send patches - preferably formatted by git format-patch - to patches at archlinux32 dot org.
summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorChristian Heusel <christian@heusel.eu>2023-04-13 17:44:48 +0200
committerLevente Polyak <anthraxx@archlinux.org>2023-05-20 00:08:12 +0200
commit645a5a9f047ada2fd76d6149ed24aa888547a52d (patch)
tree1186b38b188e3131afc9d04983691787d5d7e21e
parente1142935e508ac1f70ec3c074655124056dc7666 (diff)
pkgctl: introduce the version subcommand
Related to https://gitlab.archlinux.org/archlinux/devtools/-/issues/125 Closes #125 Signed-off-by: Christian Heusel <christian@heusel.eu> Co-Authored-By: Levente Polyak <anthraxx@archlinux.org>
-rw-r--r--contrib/completion/zsh/_devtools.in6
-rw-r--r--doc/man/pkgctl-version.1.asciidoc23
-rw-r--r--doc/man/pkgctl.1.asciidoc13
-rw-r--r--src/lib/version/version.sh47
-rw-r--r--src/pkgctl.in9
5 files changed, 98 insertions, 0 deletions
diff --git a/contrib/completion/zsh/_devtools.in b/contrib/completion/zsh/_devtools.in
index cc8d5cf..20c37ce 100644
--- a/contrib/completion/zsh/_devtools.in
+++ b/contrib/completion/zsh/_devtools.in
@@ -231,9 +231,15 @@ _pkgctl_cmds=(
"diff[Compare package files using different modes]"
"release[Release step to commit, tag and upload build artifacts]"
"repo[Manage Git packaging repositories and their configuration]"
+ "version[Show pkgctl version information]"
)
_pkgctl_args=(
+ '(-V --version)'{-V,--version}'[Show pkgctl version information]'
+ '(-h --help)'{-h,--help}'[Display usage]'
+)
+
+_pkgctl_version_args=(
'(-h --help)'{-h,--help}'[Display usage]'
)
diff --git a/doc/man/pkgctl-version.1.asciidoc b/doc/man/pkgctl-version.1.asciidoc
new file mode 100644
index 0000000..9beebf5
--- /dev/null
+++ b/doc/man/pkgctl-version.1.asciidoc
@@ -0,0 +1,23 @@
+pkgctl-version(1)
+=================
+
+Name
+----
+pkgctl-version - Show pkgctl version information
+
+Synopsis
+--------
+pkgctl version [OPTIONS]
+
+Description
+-----------
+
+Shows the current version information of pkgctl.
+
+Options
+-------
+
+*-h, --help*::
+ Show a help text
+
+include::include/footer.asciidoc[]
diff --git a/doc/man/pkgctl.1.asciidoc b/doc/man/pkgctl.1.asciidoc
index c5a6174..72cda1e 100644
--- a/doc/man/pkgctl.1.asciidoc
+++ b/doc/man/pkgctl.1.asciidoc
@@ -14,6 +14,15 @@ Description
TODO
+Options
+-------
+
+*-V, --version*::
+ Show pkgctl version information
+
+*-h, --help*::
+ Show a help text
+
Subcommands
-----------
@@ -35,6 +44,9 @@ pkgctl release::
pkgctl repo::
Manage Git packaging repositories and their configuration
+pkgctl version::
+ Show pkgctl version information
+
See Also
--------
@@ -44,5 +56,6 @@ linkman:pkgctl-db[1]
linkman:pkgctl-diff[1]
linkman:pkgctl-release[1]
linkman:pkgctl-repo[1]
+linkman:pkgctl-version[1]
include::include/footer.asciidoc[]
diff --git a/src/lib/version/version.sh b/src/lib/version/version.sh
new file mode 100644
index 0000000..d00a460
--- /dev/null
+++ b/src/lib/version/version.sh
@@ -0,0 +1,47 @@
+#!/hint/bash
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
+
+[[ -z ${DEVTOOLS_INCLUDE_VERSION_SH:-} ]] || return 0
+DEVTOOLS_INCLUDE_VERSION_SH=1
+
+_DEVTOOLS_LIBRARY_DIR=${_DEVTOOLS_LIBRARY_DIR:-@pkgdatadir@}
+
+source /usr/share/makepkg/util/message.sh
+
+set -e
+
+
+pkgctl_version_usage() {
+ local -r COMMAND=${_DEVTOOLS_COMMAND:-${BASH_SOURCE[0]##*/}}
+ cat <<- _EOF_
+ Usage: ${COMMAND} [OPTIONS]
+
+ Shows the current version information of pkgctl
+
+ OPTIONS
+ -h, --help Show this help text
+_EOF_
+}
+
+pkgctl_version_print() {
+ cat <<- _EOF_
+ pkgctl @buildtoolver@
+_EOF_
+}
+
+pkgctl_version() {
+ while (( $# )); do
+ case $1 in
+ -h|--help)
+ pkgctl_version_usage
+ exit 0
+ ;;
+ *)
+ die "invalid argument: %s" "$1"
+ ;;
+ esac
+ done
+
+ pkgctl_version_print
+}
diff --git a/src/pkgctl.in b/src/pkgctl.in
index 40f9259..1797b32 100644
--- a/src/pkgctl.in
+++ b/src/pkgctl.in
@@ -25,6 +25,7 @@ usage() {
diff Compare package files using different modes
release Release step to commit, tag and upload build artifacts
repo Manage Git packaging repositories and their configuration
+ version Show pkgctl version information
OPTIONS
-h, --help Show this help text
@@ -93,6 +94,14 @@ while (( $# )); do
pkgctl_release "$@"
exit 0
;;
+ version|--version|-V)
+ _DEVTOOLS_COMMAND+=" $1"
+ shift
+ # shellcheck source=src/lib/version/version.sh
+ source "${_DEVTOOLS_LIBRARY_DIR}"/lib/version/version.sh
+ pkgctl_version "$@"
+ exit 0
+ ;;
*)
die "invalid command: %s" "$1"
;;